﻿/**
* PerformanceTest by Grant Skinner. Apr 21, 2009
* Visit www.gskinner.com/blog for documentation, updates and more free code.
*
*
* Copyright (c) 2009 Grant Skinner
* 
* Permission is hereby granted, free of charge, to any person
* obtaining a copy of this software and associated documentation
* files (the "Software"), to deal in the Software without
* restriction, including without limitation the rights to use,
* copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following
* conditions:
* 
* The above copyright notice and this permission notice shall be
* included in all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
* OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
* HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
* OTHER DEALINGS IN THE SOFTWARE.
**/

package performancetests {
	
	public class Functions {
		
	// Constants:
		
	// Public Properties:
		// optional property specifying the default number of iterations to run each test in the suite.
		public var iterations:uint=5;
		// optional property specifying a description to be used when reporting on this test suite:
		public var description:String = "Testing impact of function COs."
		
									
		
	// Protected Properties:
		// the number of loops to run in every test:
		protected var loops:uint = 100000;
		// properties used in the tests:
		protected var anonymousRefF:Function;
		protected var refF:Function;
		
	// Initialization:
		// because tests are instance based, you can use the constructor to set things up
		// prior to your tests running.
		public function Functions():void {
			anonymousRefF = function() {
				var a:Number = 10;
			}
			refF = sampleF;
		}
		
	// Public getter / setters:
		
	// Public Methods:
		// tare method that will be run to calculate the base time required to run the loop
		// so it can be subtracted from the other test results.
		public function tare():void {
			for (var i:uint=0; i<loops; i++) {
				var a:Number = 10;
			}
		}
		
		public function anonymous():void {
			for (var i:uint=0; i<loops; i++) {
				(function() { var a:Number = 10; })();
			}
		}
		
		public function anonymousRef():void {
			for (var i:uint=0; i<loops; i++) {
				anonymousRefF();
			}
		}
		
		public function method():void {
			for (var i:uint=0; i<loops; i++) {
				sampleF();
			}
		}
		
		public function reference():void {
			for (var i:uint=0; i<loops; i++) {
				refF();
			}
		}
		
	// Protected Methods:
		// note that protected/private methods aren't tested.
		protected function sampleF():void {
			var a:Number = 10;
		}
		
	}
	
}